-- Copyright (C) 1991-2009 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- ***************************************************************************
-- This file contains a Vhdl test bench template that is freely editable to   
-- suit user's needs .Comments are provided in each section to help the user  
-- fill out necessary details.                                                
-- ***************************************************************************
-- Generated on "09/16/2014 19:11:14"
                                                            
-- Vhdl Test Bench template for design  :  Equation1
-- 
-- Simulation tool : ModelSim (VHDL)
-- 

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;  
USE ieee.numeric_std.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_signed.all;
use ieee.std_logic_textio.all;
use std.textio.all;                              

ENTITY Equation2_vhd_tst IS
END Equation2_vhd_tst;
ARCHITECTURE Equation2_arch OF Equation2_vhd_tst IS
-- constants                                          
constant clk_period : time := 0.625 us; --16KHz                                                                                          
-- signals                                                   
SIGNAL clk_25 : STD_LOGIC;
SIGNAL clk : STD_LOGIC;
SIGNAL v : integer range 0 to 2**12-1:=511;
SIGNAL y1 : integer;
signal y2 : integer;
signal u: integer;
signal flg:integer;
COMPONENT Equation2
	PORT (
	clk : IN STD_LOGIC;
	v : in integer range 0 to 2**12-1;
	y1 : out integer;
	y2 : out integer;
	u : out integer;
	flg:out integer
	);
END COMPONENT;
BEGIN
	i1 : Equation2
	PORT MAP (
-- list connections between master ports and signals
	clk => clk,
	v => v,
	y1 => y1,
	y2 => y2,
	flg=>flg,
	u=>u
	
	);
clk_25_ge : PROCESS                                               
-- variable declarations                                     
                                
BEGIN                                                        
        -- code that executes only once 
    clk_25<='0';
	wait for 12.5 us;
	clk_25<='1';
	wait for 12.5 us;
	                                                                        
END PROCESS clk_25_ge;  
clk_ge : PROCESS                                               
-- variable declarations                                     
                                
BEGIN                                                        
        -- code that executes only once 
    clk<='0';
	wait for 10 ns;
	clk<='1';
	wait for 10 ns;
	                                                                        
END PROCESS clk_ge;  
	
readinput:	process
	   variable vline:LINE;
		variable vt:integer;

		--ҪļĿ¼޸ļ·
		--file invect:text is "D:\DuYong\Filter_VHDL\FirFullSerial\E4_7_Bin_s.txt";
		
		file invect:text is "E:\Equation2\simulation\modelsim\E4_10_Int_s.txt";
		--аݷʱע͵һе䣬ͬʱȡһеע
		--file invect:text is "D:\DuYong\Filter_VHDL\FirFullSerial\E4_7_Bin_noise.txt";
		--file invect:text is "D:\DuYong\Filter_VHDL\FirHalfSerial\E4_7_Bin_s.txt";
		--file invect:text is "D:\DuYong\Filter_VHDL\FirHalfSerial\E4_7_Bin_noise.txt";
		
	begin
	   wait until rising_edge(clk_25);
		   if not (ENDFILE(invect)) then
			   readline(invect,vline);
				read(vline,vt);
				v<= vt;
			end if;
end process readinput;
	
--	˲źyoutдıļ,Matlab
writey1:process
	   variable LineOut:line;
		variable viout: integer:=0;
		--variable viout: std_logic_vector(11 downto 0) := (others => '0');
		--ҪļĿ¼޸ļ·
		--file FileOut:text open write_mode is "D:\DuYong\Filter_VHDL\FirFullSerial\E4_7_Sout.txt";
		file FileOut:text open write_mode is "E:\Equation2\simulation\modelsim\E4_10_sout.txt";
		
		--аݷʱע͵һе䣬ͬʱȡһеע
		--file FileOut:text open write_mode is "D:\DuYong\Filter_VHDL\FirFullSerial\E4_7_Noiseout.txt";
		--file invect:text is "D:\DuYong\Filter_VHDL\FirHalfSerial\E4_7_Sout.txt";
		--file invect:text is "D:\DuYong\Filter_VHDL\FirHalfSerial\E4_7_Noiseout.txt";	
begin
		wait until rising_edge(clk_25);
		--if Hide_out='1' then
			viout:=y1;
			write(LineOut,viout,right,10);
			writeline(FileOut,LineOut);
		--end if;
	end process writey1;	
	
writey2:process
	   variable LineOut:line;
		variable viout: integer:=0;
		--variable viout: std_logic_vector(11 downto 0) := (others => '0');
		--ҪļĿ¼޸ļ·
		--file FileOut:text open write_mode is "D:\DuYong\Filter_VHDL\FirFullSerial\E4_7_Sout.txt";
		file FileOut:text open write_mode is "E:\Equation2\simulation\modelsim\E4_10_sout_y2.txt";
		
		--аݷʱע͵һе䣬ͬʱȡһеע
		--file FileOut:text open write_mode is "D:\DuYong\Filter_VHDL\FirFullSerial\E4_7_Noiseout.txt";
		--file invect:text is "D:\DuYong\Filter_VHDL\FirHalfSerial\E4_7_Sout.txt";
		--file invect:text is "D:\DuYong\Filter_VHDL\FirHalfSerial\E4_7_Noiseout.txt";	
begin
		wait until rising_edge(clk_25);
		--if Hide_out='1' then
			viout:=y2;
			write(LineOut,viout,right,10);
			writeline(FileOut,LineOut);
		--end if;
	end process writey2;	
--	v<=1010;
                                                                                
END Equation2_arch;

